# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse20026(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'display_name': 'str',
        'description': 'str',
        'schema': 'DeploymentapiresourcesresourceIdactionsSchema',
        'dependents': 'list[str]',
        'valid': 'bool',
        'org_id': 'str',
        'project_id': 'str',
        'action_type': 'str',
        'form_definition': 'DeploymentapiresourcesresourceIdactionsFormDefinition'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'display_name': 'displayName',
        'description': 'description',
        'schema': 'schema',
        'dependents': 'dependents',
        'valid': 'valid',
        'org_id': 'orgId',
        'project_id': 'projectId',
        'action_type': 'actionType',
        'form_definition': 'formDefinition'
    }

    def __init__(self, id=None, name=None, display_name=None, description=None, schema=None, dependents=None, valid=None, org_id=None, project_id=None, action_type=None, form_definition=None):  # noqa: E501
        """InlineResponse20026 - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._display_name = None
        self._description = None
        self._schema = None
        self._dependents = None
        self._valid = None
        self._org_id = None
        self._project_id = None
        self._action_type = None
        self._form_definition = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if schema is not None:
            self.schema = schema
        if dependents is not None:
            self.dependents = dependents
        if valid is not None:
            self.valid = valid
        if org_id is not None:
            self.org_id = org_id
        if project_id is not None:
            self.project_id = project_id
        if action_type is not None:
            self.action_type = action_type
        if form_definition is not None:
            self.form_definition = form_definition

    @property
    def id(self):
        """Gets the id of this InlineResponse20026.  # noqa: E501

        Resource action id  # noqa: E501

        :return: The id of this InlineResponse20026.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InlineResponse20026.

        Resource action id  # noqa: E501

        :param id: The id of this InlineResponse20026.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this InlineResponse20026.  # noqa: E501

        Resource action name  # noqa: E501

        :return: The name of this InlineResponse20026.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse20026.

        Resource action name  # noqa: E501

        :param name: The name of this InlineResponse20026.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def display_name(self):
        """Gets the display_name of this InlineResponse20026.  # noqa: E501

        Resource action display name  # noqa: E501

        :return: The display_name of this InlineResponse20026.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this InlineResponse20026.

        Resource action display name  # noqa: E501

        :param display_name: The display_name of this InlineResponse20026.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this InlineResponse20026.  # noqa: E501

        Resource action description  # noqa: E501

        :return: The description of this InlineResponse20026.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InlineResponse20026.

        Resource action description  # noqa: E501

        :param description: The description of this InlineResponse20026.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def schema(self):
        """Gets the schema of this InlineResponse20026.  # noqa: E501


        :return: The schema of this InlineResponse20026.  # noqa: E501
        :rtype: DeploymentapiresourcesresourceIdactionsSchema
        """
        return self._schema

    @schema.setter
    def schema(self, schema):
        """Sets the schema of this InlineResponse20026.


        :param schema: The schema of this InlineResponse20026.  # noqa: E501
        :type: DeploymentapiresourcesresourceIdactionsSchema
        """

        self._schema = schema

    @property
    def dependents(self):
        """Gets the dependents of this InlineResponse20026.  # noqa: E501

        Dependent resources  # noqa: E501

        :return: The dependents of this InlineResponse20026.  # noqa: E501
        :rtype: list[str]
        """
        return self._dependents

    @dependents.setter
    def dependents(self, dependents):
        """Sets the dependents of this InlineResponse20026.

        Dependent resources  # noqa: E501

        :param dependents: The dependents of this InlineResponse20026.  # noqa: E501
        :type: list[str]
        """

        self._dependents = dependents

    @property
    def valid(self):
        """Gets the valid of this InlineResponse20026.  # noqa: E501

        Resource action is valid for current state  # noqa: E501

        :return: The valid of this InlineResponse20026.  # noqa: E501
        :rtype: bool
        """
        return self._valid

    @valid.setter
    def valid(self, valid):
        """Sets the valid of this InlineResponse20026.

        Resource action is valid for current state  # noqa: E501

        :param valid: The valid of this InlineResponse20026.  # noqa: E501
        :type: bool
        """

        self._valid = valid

    @property
    def org_id(self):
        """Gets the org_id of this InlineResponse20026.  # noqa: E501

        Resource action org ID  # noqa: E501

        :return: The org_id of this InlineResponse20026.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this InlineResponse20026.

        Resource action org ID  # noqa: E501

        :param org_id: The org_id of this InlineResponse20026.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def project_id(self):
        """Gets the project_id of this InlineResponse20026.  # noqa: E501

        Resource action project ID  # noqa: E501

        :return: The project_id of this InlineResponse20026.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this InlineResponse20026.

        Resource action project ID  # noqa: E501

        :param project_id: The project_id of this InlineResponse20026.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def action_type(self):
        """Gets the action_type of this InlineResponse20026.  # noqa: E501

        Resource action type  # noqa: E501

        :return: The action_type of this InlineResponse20026.  # noqa: E501
        :rtype: str
        """
        return self._action_type

    @action_type.setter
    def action_type(self, action_type):
        """Sets the action_type of this InlineResponse20026.

        Resource action type  # noqa: E501

        :param action_type: The action_type of this InlineResponse20026.  # noqa: E501
        :type: str
        """
        allowed_values = ["RESOURCE_ACTION", "RESOURCE_EXTENSION"]  # noqa: E501
        if action_type not in allowed_values:
            raise ValueError(
                "Invalid value for `action_type` ({0}), must be one of {1}"  # noqa: E501
                .format(action_type, allowed_values)
            )

        self._action_type = action_type

    @property
    def form_definition(self):
        """Gets the form_definition of this InlineResponse20026.  # noqa: E501


        :return: The form_definition of this InlineResponse20026.  # noqa: E501
        :rtype: DeploymentapiresourcesresourceIdactionsFormDefinition
        """
        return self._form_definition

    @form_definition.setter
    def form_definition(self, form_definition):
        """Sets the form_definition of this InlineResponse20026.


        :param form_definition: The form_definition of this InlineResponse20026.  # noqa: E501
        :type: DeploymentapiresourcesresourceIdactionsFormDefinition
        """

        self._form_definition = form_definition

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse20026, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse20026):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
